# Entities

## Entities

* [`Domain`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`DomainEvent`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`Transfer`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NewOwner`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NewResolver`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NewTTL`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`Account`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`Registration`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`RegistrationEvent`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NameRegistered`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NameRenewed`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NameTransferred`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`Resolver`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`ResolverEvent`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`AddrChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`MulticoinAddrChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`NameChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`AbiChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`PubKeyChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`TextChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`ContentHashChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`InterfaceChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)
* [`AuthorisationChanged`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)

## Domain

Description:

| Field           | Type                                                                                          | Description                                                                                                     |
| --------------- | --------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- |
| id              | ID!                                                                                           | The namehash of the name                                                                                        |
| name            | String                                                                                        | The human readable name, if known. Unknown portions replaced with hash in square brackets (eg, foo.\[1234].pls) |
| labelName       | String                                                                                        | The human readable label name (imported from CSV), if known                                                     |
| labelhash       | Bytes                                                                                         | keccak256(labelName)                                                                                            |
| parent          | Domain                                                                                        | The namehash (id) of the parent name                                                                            |
| subdomains      | [`Domain!`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)      | Can count domains from length of array                                                                          |
| subdomainCount  | Int!                                                                                          | The number of subdomains                                                                                        |
| resolvedAddress | account                                                                                       | Address logged from current resolver, if any                                                                    |
| owner           | Account!                                                                                      |                                                                                                                 |
| resolver        | Resolver                                                                                      |                                                                                                                 |
| ttl             | BigInt                                                                                        |                                                                                                                 |
| isMigrated      | Boolean!                                                                                      |                                                                                                                 |
| createdAt       | BigInt!                                                                                       |                                                                                                                 |
| events          | [`DomainEvent!`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference) |                                                                                                                 |

## Transfer

Description:

| Field         | Type    | Description |
| ------------- | ------- | ----------- |
| id            | ID!     |             |
| domain        | Domain! |             |
| blockNumber   | Int!    |             |
| TransactionID | Bytes!  |             |

## NewOwner

Description:

| Field         | Type     | Description |
| ------------- | -------- | ----------- |
| id            | ID!      |             |
| parentDomain  | Domain!  |             |
| domain        | Domain!  |             |
| TransactionID | Bytes!   |             |
| owner         | Account! |             |

## NewResolver

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| domain        | Domain!   |             |
| blockNumber   | Int!      |             |
| TransactionID | Bytes!    |             |
| resolver      | Resolver! |             |

## NewTTL

Description:

| Field         | Type    | Description |
| ------------- | ------- | ----------- |
| id            | ID!     |             |
| domain        | Domain! |             |
| blockNumber   | Int!    |             |
| transactionID | Bytes!  |             |
| ttl           | BigInt! |             |

## Account

Description:

| Field        | Type                                                                                           | Description |
| ------------ | ---------------------------------------------------------------------------------------------- | ----------- |
| id           | ID!                                                                                            |             |
| domain       | [`Domain!`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference)       |             |
| registration | [`Registration!`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference) |             |

## Registration

Description:

| Field            | Type                                                                                               | Description |
| ---------------- | -------------------------------------------------------------------------------------------------- | ----------- |
| id               | ID!                                                                                                |             |
| domain           | Domain                                                                                             |             |
| registrationDate | BigInt!                                                                                            |             |
| expiryDate       | BigInt!                                                                                            |             |
| cost             | BigInt!                                                                                            |             |
| registrant       | Account!                                                                                           |             |
| labelName        | String                                                                                             |             |
| events           | [`RegistrationEven!`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference) |             |

## RegistrationEvent

Description:

| Field         | Type              | Description |
| ------------- | ----------------- | ----------- |
| id            | ID!               |             |
| registration  | RegistrationEvent |             |
| blockNumber   | Int!              |             |
| transactionID | Bytes!            |             |

## NameRegistered

Description:

| Field         | Type          | Description |
| ------------- | ------------- | ----------- |
| id            | ID!           |             |
| registration  | Registration! |             |
| blockNumber   | Int!          |             |
| transactionID | Bytes!        |             |
| registrant    | Account!      |             |
| expiryDate    | BigInt!       |             |

## NameRenewed

Description:

| Field         | Type          | Description |
| ------------- | ------------- | ----------- |
| id            | ID!           |             |
| registration  | Registration! |             |
| blockNumber   | Int!          |             |
| transactionID | Bytes!        |             |
| expiryDate    | BigInt!       |             |

## NameTransferred

Description:

| Field         | Type          | Description |
| ------------- | ------------- | ----------- |
| id            | ID!           |             |
| registration  | Registration! |             |
| blockNumber   | Int!          |             |
| transactionID | Bytes!        |             |
| newOwner      | Account!      |             |

## Resolver

Description:

| Field      | Type                                                                                            | Description                                    |
| ---------- | ----------------------------------------------------------------------------------------------- | ---------------------------------------------- |
| id         | ID!                                                                                             | Concatenation of resolver address and namehash |
| domain     | Domain                                                                                          |                                                |
| address    | Bytes!                                                                                          | Address of resolver contract                   |
| addr       | Account                                                                                         | Current value of addr record (per events)      |
| contenHash | Bytes                                                                                           | Content hash, in binary format                 |
| texts      | \[String!]                                                                                      | Set of observed text record keys               |
| cointTypes | \[BigInt!]                                                                                      | Set of observed SLIP-44 coin types             |
| events     | [`ResolverEvent!`](https://docs.pulse.domains/contract-api-reference/subgraph/broken-reference) |                                                |

## ResolverEvent

Description:

| Field         | Type      | Description                               |
| ------------- | --------- | ----------------------------------------- |
| id            | ID!       | Concatenation of block number and log ID  |
| resolver      | Resolver! | Used to derive relationships to Resolvers |
| blockNumber   | Int!      |                                           |
| transactionID | Bytes!    |                                           |

## AddrChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| addr          | Account!  |             |

## MulticoinAddrChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| coinType      | BigInt!   |             |
| addr          | Bytes!    |             |

## NameChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| name          | String!   |             |

## AbiChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| contentType   | BigInt!   |             |

## PubkeyChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| x             | Bytes!    |             |
| y             | Bytes!    |             |

## TextChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| key           | String!   |             |
| value         | String    |             |

## ContenthashChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| hash          | Bytes!    |             |

## InterfaceChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| interfacedID  | Bytes!    |             |
| implementer   | Bytes!    |             |

## AuthorisationChanged

Description:

| Field         | Type      | Description |
| ------------- | --------- | ----------- |
| id            | ID!       |             |
| resolver      | Resolver! |             |
| blockNumber   | Int!      |             |
| transactionID | Bytes!    |             |
| owner         | Bytes!    |             |
| target        | Bytes!    |             |
| isAuthorized  | Boolean!  |             |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pulse.domains/contract-api-reference/subgraph/entities.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
